
function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}


Ext.define('DSS.addon.TimedEvents', {
	fExpertMode:false,
    extend: 'DSS.addon.Framework',

    config: {
        appName: 'te_title',
        appId: 'system-addon-timed-events',
        appVersion: '1.2.0',
        appIcon: 'images/app_icon.png'
    },

    getHelp: function() {
        return Ext.create('Ext.Component', {
            loader: {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad: true,
                disableCaching: false
            }
        });
    },

    getContent: function() {
        
        var me=this;
        /* Parameter:
         *   * editor config
         *   * button config
         *   * store config   
         *   * columns
         *   * defaultSortCol
         * */
        
        var oConfig={
                defaultSortCol:'name',
                disabledProperty:'disabled',
                storeConfig: {
                    storeId : 'timedeventStore',
                    fields : [ {name:'id'}, 
                               {name:'disabled', sortType:'asBoolean'}, 
                               {name:'name', sortType:'asUCText'}, 
                               {name:'actions', sortType:'asAction'}, 
                               {name:'time', sortType:'asTime'}, 
                               {name: 'conditions',  sortType: 'asUCText' },
                               {name:'recurrence', sortType:'asRecurrence'} ,
                               ]  
                },
                multiselect:true,
                columns: [{
                    header : _('Active'),
                    dataIndex : 'disabled',
                    resizable : false,
                    xtype: 'disabledcolumn', 
                    width : 50
                }, {
                    header : _('Name'),
                    dataIndex : 'name',
                    xtype: 'textcolumn', 
                    width : 200
                }, {
                    header : _('Activity'),
                    dataIndex : 'actions', 
                    maintainFlex : true,
                    flex : 5,
                    xtype: 'actioncolumn'
                }, {
                    header: _('Time'),
                    dataIndex: 'time',
                    xtype: 'timecolumn', 
                    width: 200
                }, {
                    header: _('Recurrence'),
                    dataIndex: 'recurrence',
                    xtype: 'recurrencecolumn', 
                    width: 160
                },{
                    header: _('Conditions'),
                    dataIndex: 'conditions', 
                    xtype: 'conditioncolumn',
                    maintainFlex: true,
                    flex: 3,
                    customRendererOptions:{hideEnabled:true,hideWeekdays:false,hideGenericSystemStates:false,hideZoneStates:false,hideTimeframe:false,filterSystemState:[],
                    	stateTitles:[{name:'daylight',value:'active',title:_('grid_daylight_true')},{name:'daylight',value:'inactive',title:_('grid_daylight_false')},
                    	             {name:'daynight',value:'active',title:_('grid_daynight_true')},{name:'daynight',value:'inactive',title:_('grid_daynight_false')},
                    	             {name:'panic',value:'active',title:_('grid_panic_active')},{name:'panic',value:'inactive',title:_('grid_panic_inactive')},
                    	             {name:'presence',value:'present',title:_('grid_presence_present')},{name:'presence',value:'absent',title:_('grid_presence_absent')},
                    	             {name:'fire',value:'active',title:_('grid_fire_active')},{name:'fire',value:'inactive',title:_('grid_fire_inactive')},
                    	             {name:'hail',value:'active',title:_('grid_hail_active')},{name:'hail',value:'inactive',title:_('grid_hail_inactive')},
                    	             {name:'wind',value:'active',title:_('grid_wind_active')},{name:'wind',value:'inactive',title:_('grid_wind_inactive')},
                    	             {name:'rain',value:'active',title:_('grid_rain_active')},{name:'rain',value:'inactive',title:_('grid_rain_inactive')},
                    	             {name:'panic',value:'active',title:_('grid_panic_active')},{name:'panic',value:'inactive',title:_('grid_panic_inactive')},
                    	             {name:'alarm',value:'active',title:_('grid_alarm_active')},{name:'alarm',value:'inactive',title:_('grid_alarm_inactive')},
                    	             {name:'alarm2',value:'active',title:_('grid_alarm2_active')},{name:'alarm2',value:'inactive',title:_('grid_alarm2_inactive')},
                    	             {name:'alarm3',value:'active',title:_('grid_alarm3_active')},{name:'alarm3',value:'inactive',title:_('grid_alarm3_inactive')},
                    	             {name:'alarm4',value:'active',title:_('grid_alarm4_active')},{name:'alarm4',value:'inactive',title:_('grid_alarm4_inactive')},
                    	             {name:'holiday', value:'on',title:_('grid_holiday_on')},{name:'holiday', value:'off',title:_('grid_holiday_off')}]}
                }],     
                buttonText: {
                    newButton: _('New event'),
                    editButton: _('Edit event'),
                    enableButton:_('Enable event'),
                    disableButton:_('Disable event'),
                    testButton: _('Test event'),
                    deleteButton: _('Delete event'),
                },
                defaultNewEntryValues: {
                	conditions:{systemState:[{name:'holiday',value:'off'}]}
                },
                editorConfig:{
                    title : _('Timed Event'),
                    staticControls : [ {
                        type : 'text',
                        label : _('Name'),
                        id : 'name'
                    }, {
                        type: 'hidden',
                        label: 'id',
                        id: 'id'
                    }],
                    tabControls : [{
                        tabLabel : _('time of execution'),
                        tabDescription : _('Choose the time, when the activities should be executed.'),
                        content : [{
                                label: _('Time'),
                                type : 'timeReference',
                                id : 'time'
                           },{
                               type : 'weekdaySelection',
                               id : 'recurrence',
                               label: _('Recurrence'),
                               flex : true
                          }]
                    }, {
                        tabLabel : _('Activity'),
                        tabDescription : _('Choose the activities, which should be executed.'),
                        content : [{
                            type : 'ActionConfigurator',
                            id : 'actions',
                            flex : true
                        }]
                    }, {
                        tabLabel : _('Conditions'),
                        tabDescription : _('Choose the conditions.'),
                        content : [{
                            type : 'ConditionConfigurator',
                            id : 'conditions',
                            conditions:[
                                        {type:'singleItem',title:_('state_daynight'),entry:[
                                              {type:'state',name:'daylight',value:'active',title:Ext.String.format2(_('daynight_bright'),{
		                                            	duskTime:dss.staticDataModel.nowDusk,
		                                            	dawnTime:dss.staticDataModel.nowDawn
		                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_true'),{
		                                            	duskTime:dss.staticDataModel.nowDusk,
		                                            	dawnTime:dss.staticDataModel.nowDawn
		                                            })},
                                              {type:'state',name:'daylight',value:'inactive',title:Ext.String.format2(_('daynight_dark'),{
	                                            	duskTime:dss.staticDataModel.nowDusk,
	                                            	dawnTime:dss.staticDataModel.nowDawn
	                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_false'),{
	                                            	duskTime:dss.staticDataModel.nowDusk,
	                                            	dawnTime:dss.staticDataModel.nowDawn
	                                            })},
                                              {type:'state',name:'daynight',value:'active',title:Ext.String.format2(_('daynight_day'),{
	                                              	sunriseTime:dss.staticDataModel.nowSunrise,
	                                            	sunsetTime:dss.staticDataModel.nowSunset
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_true'),{
	                                              	sunriseTime:dss.staticDataModel.nowSunrise,
	                                            	sunsetTime:dss.staticDataModel.nowSunset
	                                            })},
                                              {type:'state',name:'daynight',value:'inactive',title:Ext.String.format2(_('daynight_night'),{
	                                              	sunriseTime:dss.staticDataModel.nowSunrise,
	                                            	sunsetTime:dss.staticDataModel.nowSunset
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_false'),{
	                                              	sunriseTime:dss.staticDataModel.nowSunrise,
	                                            	sunsetTime:dss.staticDataModel.nowSunset
	                                            })},
	                                            
	                                            ]},
                                        {type:'timeframe',title:_('Timeframe')},
                                        {type:'deviceState',title:_('automatic devices')},
                                        {type:'singleItem',title:_('state_presence'),entry: [
                                               {type:'state',name:'presence',value:'present',title:_('presence_present'),gridText:_('grid_presence_present')},
                                               {type:'state',name:'presence',value:'absent',title:_('presence_absent'),gridText:_('grid_presence_absent')}]},                                               
                                        {type:'singleItem',title:_('state_holiday'),entry: [
                                               {type:'state',name:'holiday',value:'on',title:_('holiday_on'),gridText:_('grid_holiday_on')},
                                               {type:'state',name:'holiday',value:'off',title:_('holiday_off'),gridText:_('grid_holiday_off')}]},
	                                   {type:'singleItem',title:_('Rain'),entry: [
                                               {type:'state',name:'rain',value:'active',title:_('rain active'),gridText:_('grid_rain_active')},
                                               {type:'state',name:'rain',value:'inactive',title:_('rain inactive'),gridText:_('grid_rain_inactive')}]},
	                                   {type:'singleItem',title:_('Wind'),entry: [
                                               {type:'state',name:'wind',value:'active',title:_('wind active'),gridText:_('grid_wind_active')},
                                               {type:'state',name:'wind',value:'inactive',title:_('wind inactive'),gridText:_('grid_wind_inactive')}]},
	                                   {type:'singleItem',title:_('Hail'),entry: [
                                               {type:'state',name:'hail',value:'active',title:_('hail active'),gridText:_('grid_hail_active')},
                                               {type:'state',name:'hail',value:'inactive',title:_('hail inactive'),gridText:_('grid_hail_inactive')}]},
   	                                   {type:'singleItem',title:_('state_panic'),entry: [
                                               {type:'state',name:'panic',value:'active',title:_('panic_active'),gridText:_('grid_panic_active')},
                                               {type:'state',name:'panic',value:'inactive',title:_('panic_inactive'),gridText:_('grid_panic_inactive')}]},
 	                                   {type:'singleItem',title:_('state_alarm'),entry: [
                                               {type:'state',name:'alarm',value:'active',title:_('alarm_active'),gridText:_('grid_alarm_active')},
                                               {type:'state',name:'alarm',value:'inactive',title:_('alarm_inactive'),gridText:_('grid_alarm_inactive')}]},
   	                                   {type:'singleItem',title:_('state_alarm2'),entry: [
                                               {type:'state',name:'alarm2',value:'active',title:_('alarm2_active'),gridText:_('grid_alarm2_active')},
                                               {type:'state',name:'alarm2',value:'inactive',title:_('alarm2_inactive'),gridText:_('grid_alarm2_inactive')}]},
     	                               {type:'singleItem',title:_('state_alarm3'),entry: [
                                               {type:'state',name:'alarm3',value:'active',title:_('alarm3_active'),gridText:_('grid_alarm3_active')},
                                               {type:'state',name:'alarm3',value:'inactive',title:_('alarm3_inactive'),gridText:_('grid_alarm3_inactive')}]},
   	                                   {type:'singleItem',title:_('state_alarm4'),entry: [
                                               {type:'state',name:'alarm4',value:'active',title:_('alarm4_active'),gridText:_('grid_alarm4_active')},
                                               {type:'state',name:'alarm4',value:'inactive',title:_('alarm4_inactive'),gridText:_('grid_alarm4_inactive')}]},
                                        {type:'zonestate',title:_('ZoneState')}
                            ],
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){                        
                        dss.raiseEvent('system-addon-timed-events.config', {
                            actions : 'save',
                            value : Ext.JSON.encode(values)
                        })
                        me.waitAndReload(grid);
                    },
                    'enableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('system-addon-timed-events.config', {
                            actions : 'enable',
                            id : Ext.JSON.encode(idVal)
                        });
                        me.waitAndReload(grid);
                     },
                    'disableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('system-addon-timed-events.config', {
                            actions : 'disable',
                            id : Ext.JSON.encode(idVal)
                        })
                        me.waitAndReload(grid);
                    },
                    'deleteEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('system-addon-timed-events.config', {
                            actions : 'delete',
                            id : Ext.JSON.encode(idVal)
                        })
                        me.waitAndReload(grid);
                    },
                    'testEntry':function (grid,entry){
                        dss.ajaxAssyncRequestWithoutAnswer("/json/event/raise",
                                {name:'action_execute', parameter:  "path=/scripts/system-addon-timed-events/entries/" + entry.get('id')  + ";ignoreConditions=ignoreConditions"});                       
                    }
                }
        };
                      
        
        if (getParameterByName('mode')=='expert') {
            oConfig.editorConfig.tabControls[1].content[0].withDelay=true;
            oConfig.editorConfig.tabControls[0].content[0].randomize=1800;
            this.fExpertMode=true;
        }
        return Ext.create('DSS.gridPanel', oConfig);
    },
    waitAndReload : function(grid) {
    	grid.setStatus(_('Saving ...'));
        var me = this;
        var iSubscriptID = Math.floor(Math.random() * 100000000000);
        dss.ajaxSyncRequest('/json/event/subscribe', {
            subscriptionID : iSubscriptID,
            name : 'system-addon-timed-events.saved'
        });
        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
            subscriptionID : iSubscriptID,
            timeout : 60 * 1000
        }, function() {
            me.loadParameter(grid);
            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                subscriptionID : iSubscriptID,
                name : 'system-addon-timed-events.saved'
            });
        });
    },
    loadParameter : function(grid) {
    	grid.setStatus(_('Loading ...'));
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/system-addon-timed-events/entries/*(*)/*(*)/*(*)/*(*)'
        });
        var result = Ext.JSON.decode(sString);
        var oTimedEvent=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                             {name:'id',type:'simple'},
                                                             {name:'random',type:'simple'},
                                                             {name:'disabled',type:'condition/enabled'},
                                                             {name:'holiday',type:'condition/state'},
                                                             {name:'actions',type:'action'},
                                                             {name: 'conditions', type: 'condition'},
                                                             {name:'time',type:'time'},  //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
                                                             {name:'recurrence',type:'recurrence'}]);  // recurrence:  0 : MO,TU,WE,TH,FR,SA,SO        
        if (oTimedEvent!=null) {
            var oResultObject=[];
            for (var iIndex=0;iIndex<oTimedEvent.length;iIndex++) {
                var fAdd=true;
                if (!this.fExpertMode) {
	                if (oTimedEvent[iIndex]['holiday']!=null)
	                    if (oTimedEvent[iIndex]['holiday']=='on')
	                        fAdd=false;
                }
                if (fAdd)
                    oResultObject.push(oTimedEvent[iIndex]);
            }
            grid.loadParameter(oResultObject);
            
        }
        grid.setStatus(_('Ready'));
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/timed-events.po']);
    var timedevents = Ext.create('DSS.addon.TimedEvents');
    timedevents.initPage();
});

